<?php

if (!defined('ABSPATH'))
    exit;

require_once 'fn.atipay.php';
define ('ATIGATE_URL','https://mipg.atipay.net/v1/');
function Load_AtiPay_PG()
{

    if (class_exists('WC_Payment_Gateway') && !class_exists('WC_ATIPAY_PG') && !function_exists('Woocommerce_Add_AtiPay_Gateway')) {


        add_filter('woocommerce_payment_gateways', 'Woocommerce_Add_AtiPay_PG');

        function Woocommerce_Add_AtiPay_PG($methods)
        {
            $methods[] = 'WC_ATIPAY_PG';
            return $methods;
        }

        add_filter('woocommerce_currencies', 'add_currency');

        function add_currency($currencies)
        {

            $currencies['IRR'] = __(atipay_message('IRR'), 'woocommerce');
            $currencies['IRT'] = __(atipay_message('IRT'), 'woocommerce');
            $currencies['IRHR'] = __(atipay_message('IRHR'), 'woocommerce');
            $currencies['IRHT'] = __(atipay_message('IRHT'), 'woocommerce');

            return $currencies;
        }

        add_filter('woocommerce_currency_symbol', 'atipay_add_currency', 10, 2);

        function atipay_add_currency($currency_symbol, $currency)
        {
            $currency_symbol = atipay_message($currency);
            return $currency_symbol;
        }

        class WC_ATIPAY_PG extends WC_Payment_Gateway
        {

            public function __construct()
            {

                $this->has_fields = false;
                $this->id = 'WC_ATIPAY_PG';
                $this->method_title = __(atipay_message('atipay_main_title'), 'woocommerce');
                $this->method_description = __(atipay_message('atipay_setting'), 'woocommerce');
                $this->icon = apply_filters('WC_ATIPAY_PG_logo', WP_PLUGIN_URL . "/" . plugin_basename(dirname(__FILE__)) . '/assets/images/atipay_logo.jpg');
                $this->generate_plugin_setting_form();
                $this->init_settings();

                $this->title = $this->settings['title'];
                $this->description = $this->settings['description'];

                $this->apikey = $this->settings['apikey'];
                $this->auto_redirect = $this->settings['auto_redirect'];

                $this->msg_show_success = $this->settings['msg_show_success'];
                $this->msg_show_failed = $this->settings['msg_show_failed'];

                if (version_compare(WOOCOMMERCE_VERSION, '2.0.0', '>=')) {
                    add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));
                }else{
                    add_action('woocommerce_update_options_payment_gateways', array($this, 'process_admin_options'));
                }

                add_action('woocommerce_receipt_' . $this->id . '', array($this, 'start_ATIPAY_PG'));
                add_action('woocommerce_api_' . strtolower(get_class($this)) . '', array($this, 'CallBack_ATIPAY_PG'));
            }


            public function admin_options()
            {
                parent::admin_options();
            }

            public function generate_plugin_setting_form()
            {

                $this->form_fields = apply_filters('WC_ATIPAY_PG_Config', array(
                        'base_confing' => array(
                            'title' => __(atipay_message('basic_setting'), 'woocommerce'),
                            'type' => 'title',
                            'description' => '',
                        ),
                        'enabled' => array(
                            'title' => __('وضعیت', 'woocommerce'),
                            'type' => 'checkbox',
                            'label' => __(atipay_message('activate_atigate'), 'woocommerce'),
                            'description' => __(atipay_message('activate_atigate_desc'), 'woocommerce'),
                            'default' => 'yes',
                            'desc_tip' => true,
                        ),
                        'title' => array(
                            'title' => __(atipay_message('title'), 'woocommerce'),
                            'type' => 'text',
                            'description' => __(atipay_message('atigate_title_purchase'), 'woocommerce'),
                            'default' => __(atipay_message('atipay_main_title'), 'woocommerce'),
                            'desc_tip' => true,
                        ),
                        'description' => array(
                            'title' => __(atipay_message('desc'), 'woocommerce'),
                            'type' => 'text',
                            'desc_tip' => true,
                            'description' => __(atipay_message('atipay_title_processing'), 'woocommerce'),
                            'default' => __(atipay_message('atigate_title_secure'), 'woocommerce')
                        ),
                        'account_confing' => array(
                            'title' => __(atipay_message('setting'), 'woocommerce'),
                            'type' => 'title',
                            'description' => '',
                        ),
                        'apikey' => array(
                            'title' => __(atipay_message('atigate_apikey'), 'woocommerce'),
                            'type' => 'text',
                            'description' => __(atipay_message('atipay_apikey_desc'), 'woocommerce'),
                            'default' => '',
                            'desc_tip' => true
                        ),
                        'auto_redirect' => array(
                            'title' => __('ارسال خودکار مشتری به درگاه', 'woocommerce'),
                            'type' => 'checkbox',
                            'label' => __(atipay_message('auto_redirect'), 'woocommerce'),
                            'description' => __(atipay_message('auto_redirect_desc'), 'woocommerce'),
                            'default' => 'yes',
                            'desc_tip' => true,
                        ),
//                        'price_currency' => array(
//                            'title' => __(atipay_message('price_in_toman'), 'woocommerce'),
//                            'type' => 'checkbox',
//                            'label' => __(atipay_message('price_in_toman_desc'), 'woocommerce'),
//                            'description' => __(atipay_message('atigate'), 'woocommerce'),
//                            'default' => 'no',
//                            'desc_tip' => true,
//                        ),
                        'atiwebgate' => array(
                            'title' => __(atipay_message('atigate_activate'), 'woocommerce'),
                            'type' => 'checkbox',
                            'label' => __(atipay_message('atigate_activate_desc'), 'woocommerce'),
                            'description' => __(atipay_message('atigate'), 'woocommerce'),
                            'default' => '',
                            'desc_tip' => true,
                        ),
                        'payment_confing' => array(
                            'title' => __(atipay_message('payment_setting'), 'woocommerce'),
                            'type' => 'title',
                            'description' => '',
                        ),
                        'msg_show_success' => array(
                            'title' => __(atipay_message('sm'), 'woocommerce'),
                            'type' => 'textarea',
                            'description' => __(atipay_message('sm_desc'), 'woocommerce'),
                            'default' => __(atipay_message('sm_default'), 'woocommerce'),
                        ),
                        'msg_show_failed' => array(
                            'title' => __(atipay_message('fm'), 'woocommerce'),
                            'type' => 'textarea',
                            'description' => __(atipay_message('fm_desc'), 'woocommerce'),
                            'default' => __(atipay_message('fm_default'), 'woocommerce'),
                        ),
                    )
                );
            }

            public function process_payment($order_id)
            {
                $order = new WC_Order($order_id);
                return array(
                    'result' => 'success',
                    'redirect' => $order->get_checkout_payment_url(true)
                );
            }



            public function start_ATIPAY_PG($order_id)
            {


                global $woocommerce;
                $woocommerce->session->order_id_AtiPay = $order_id;
                $order = new WC_Order($order_id);
                $currency = $order->get_order_currency();
                $currency = apply_filters('WC_ATIPAY_PG_Currency', $currency, $order_id);

                //get token
                $Amount = intval($order->order_total);
                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_before_check_currency', $Amount, $currency);
                if (strpos($currency,'تومان') !== false || strtolower($currency) == strtolower('IRT') || strtolower($currency) == strtolower('TOMAN') || strtolower($currency) == strtolower('Iran TOMAN') || strtolower($currency) == strtolower('Iranian TOMAN') || strtolower($currency) == strtolower('Iran-TOMAN') || strtolower($currency) == strtolower('Iranian-TOMAN') || strtolower($currency) == strtolower('Iran_TOMAN') || strtolower($currency) == strtolower('Iranian_TOMAN') || strtolower($currency) == strtolower('تومان') || strtolower($currency) == strtolower('تومان ایران')
                ){
                    $Amount = $Amount * 10;
                }


                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_after_check_currency', $Amount, $currency);
                $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_irt', $Amount, $currency);
                $Amount = apply_filters('woocommerce_order_amount_total_AtiPay_gateway', $Amount, $currency);

//                $isToman = $this->price_currency;
//                if ($isToman == 'no'){
//                    //amount wont change
//                }else{
//                    $Amount = $Amount * 10;
//                }


                $apikey = $this->apikey;
                $CallbackUrl = add_query_arg('wc_order', $order_id, WC()->api_request_url('WC_ATIPAY_PG'));

                $products = array();
                $order_items = $order->get_items();
                foreach ((array)$order_items as $product) {
                    $products[] = $product['name'] . ' (' . $product['qty'] . ') ';
                }
                $products = implode(' - ', $products);

                $Description = 'خرید به شماره سفارش : ' . $order->get_order_number() . ' | خریدار : ' . $order->billing_first_name . ' ' . $order->billing_last_name . ' | محصولات : ' . $products;
                $Mobile = get_post_meta($order_id, '_billing_phone', true) ? get_post_meta($order_id, '_billing_phone', true) : '-';
                $Email = $order->billing_email;
                $Paymenter = $order->billing_first_name . ' ' . $order->billing_last_name;
                $ResNumber = intval($order->get_order_number());

                //Hooks for iranian developer
                $Description = apply_filters('WC_ATIPAY_PG_Description', $Description, $order_id);
                $Mobile = apply_filters('WC_ATIPAY_PG_Mobile', $Mobile, $order_id);
                $Email = apply_filters('WC_ATIPAY_PG_Email', $Email, $order_id);
                $Paymenter = apply_filters('WC_ATIPAY_PG_Paymenter', $Paymenter, $order_id);
                $ResNumber = apply_filters('WC_ATIPAY_PG_ResNumber', $ResNumber, $order_id);
                do_action('WC_ATIPAY_PG_Gateway_Payment', $order_id, $Description, $Mobile);
                $Email = !filter_var($Email, FILTER_VALIDATE_EMAIL) === false ? $Email : '';
                $Mobile = preg_match('/^09[0-9]{9}/i', $Mobile) ? $Mobile : '';

                $accati = ($this->settings['atiwebgate'] == 'no') ? 'https://www.AtiPay.com/pg/StartPay/%s/' : 'https://www.AtiPay.com/pg/StartPay/%s/atiGate';

                $data = array('MerchantID' => $this->apikey, 'Amount' => $Amount, 'CallbackURL' => $CallbackUrl, 'Description' => $Description);
                $token_params = array('apiKey' => $this->apikey,
                    'redirectUrl' => $CallbackUrl,
                    'invoiceNumber' => $ResNumber,
                    'amount' => $Amount,
                    'cellNumber' => $Mobile,
                );
                $r = wsRequestPost(ATIGATE_URL . 'get-token', $token_params);
                if ($r['status'] != '1') {

                    echo "cURL Error #:";
                    $Fault = '';
                    $Message = atipay_message('token_error');
                    $Note = sprintf(__(atipay_message('token_error'), 'woocommerce'));
                    $Note = apply_filters('WC_ATIPAY_PG_Send_to_Gateway_Failed_Note', $Note, $order_id, $Fault);
                    $order->add_order_note($Note);

                    $Fault = '';
                    $Notice = sprintf(__(atipay_message('token_error'), 'woocommerce'), $Message);
                    $Notice = apply_filters('WC_ATIPAY_PG_Send_to_Gateway_Failed_Notice', $Notice, $order_id, $Fault);
                    if ($Notice)
                        wc_add_notice($Notice, 'error');
                    do_action('WC_ATIPAY_PG_Send_to_Gateway_Failed', $order_id, $Fault);
                } else {
                    $token = $r['token'];
                    $form = '<form action="' .ATIGATE_URL . 'redirect-to-gateway" method="POST" class="AtiPay-checkout-form" id="AtiPay-checkout-form" name="AtiPay-checkout-form">
						<input type="hidden" name="token" value="'.$token.'">
						<input type="submit" name="AtiPay_submit" class="button alt" id="AtiPay-payment-button" value="پرداخت"/>
						
					 </form><br/> ';
//                    	 $form = $from . "<a class='button cancel' href='$woocommerce->cart->get_checkout_url()'>بازگشت</a>";

                    $form = apply_filters('WC_ATIPAY_PG_Form', $form, $order_id, $woocommerce);

                    do_action('WC_ATIPAY_PG_Gateway_Before_Form', $order_id, $woocommerce);
                    echo $form;
                    if ($this->auto_redirect == 'yes'){
                        echo '<script>document.forms[\'AtiPay-checkout-form\'].submit();</script>';
                    }
                    do_action('WC_ATIPAY_PG_Gateway_After_Form', $order_id, $woocommerce);

                }
            }



            public function CallBack_ATIPAY_PG()
            {


                $InvoiceNumber = isset($_POST['InvoiceNumber']) ? $_POST['InvoiceNumber'] : '';

                global $woocommerce;

                $params = $_POST;
                if (isset($_GET['wc_order']))
                    $order_id = $_GET['wc_order'];
                else if ($InvoiceNumber) {
                    $order_id = $InvoiceNumber;
                } else {
                    $order_id = $woocommerce->session->order_id_AtiPay;
                    unset($woocommerce->session->order_id_AtiPay);
                }

                if ($order_id) {
                    $order = new WC_Order($order_id);
                    $currency = $order->get_order_currency();
                    $currency = apply_filters('WC_ATIPAY_PG_Currency', $currency, $order_id);

                    if ($order->status != 'completed') {

                        $apikey = $this->apikey;

                        if ($params['state'] == "OK") {

                            $apikey = $this->apikey;
                            $Amount = intval($order->order_total);
                            $Amount = apply_filters('woocommerce_order_amount_total_IRANIAN_gateways_before_check_currency', $Amount, $currency);
                            if (strpos($currency,'تومان') !== false || strtolower($currency) == strtolower('IRT') || strtolower($currency) == strtolower('TOMAN') || strtolower($currency) == strtolower('Iran TOMAN') || strtolower($currency) == strtolower('Iranian TOMAN') || strtolower($currency) == strtolower('Iran-TOMAN') || strtolower($currency) == strtolower('Iranian-TOMAN') || strtolower($currency) == strtolower('Iran_TOMAN') || strtolower($currency) == strtolower('Iranian_TOMAN') || strtolower($currency) == strtolower('تومان') || strtolower($currency) == strtolower('تومان ایران')
                            ){
                                $Amount = $Amount * 10;
                            }

                            $verify_params = array('apiKey'=>$apikey,
                                'referenceNumber'=>$params['referenceNumber']
                            );

                            $_r = wsRequestPost(ATIGATE_URL . 'verify-payment',$verify_params);
                            if (isset($_r['amount']) && !empty($_r['amount']) && $_r['amount'] == $Amount) {
                                $Status = 'completed';
                                $Transaction_ID = $params['referenceNumber'];
                                $traceNumber = $params['traceNumber'];
                                $Fault = '';
                                $Message = '';
                            } else {
                                $Status = 'failed';
                                $Fault = $params['Status'];
                                $Message = 'تراکنش ناموفق بود';
                            }
                        } else {
                            $Status = 'failed';
                            $Fault = '';
                            $Message = 'تراکنش انجام نشد .';
                        }

                        if ($Status == 'completed' && isset($traceNumber) && $traceNumber!= 0) {

                            update_post_meta($order_id, '_transaction_id', $traceNumber);


                            $order->payment_complete($traceNumber);
                            $woocommerce->cart->empty_cart();

                            $Note = sprintf(__(atipay_message('success_payment'), 'woocommerce'), $Transaction_ID);
                            $Note = apply_filters('WC_ATIPAY_PG_Return_from_Gateway_Success_Note', $Note, $order_id, $traceNumber);
                            if ($Note){
                                $order->add_order_note($Note, 1);
                            }

                            $Notice = wpautop(wptexturize($this->msg_show_success));
                            $Notice = str_replace("{transaction_id}", $traceNumber, $Notice);                     
                            $Notice = apply_filters('WC_ATIPAY_PG_Return_from_Gateway_Success_Notice', $Notice, $order_id, $Transaction_ID);                          

                            do_action('WC_ATIPAY_PG_Return_from_Gateway_Success', $order_id, $traceNumber);
                            if ($Notice){
                                wc_add_notice($Notice, 'success');
                            }
                            wp_redirect(add_query_arg('wc_status', 'success', $this->get_return_url($order)));
                            exit;
                        } else {
                            $Note = sprintf(__('خطا در تایید پرداخت', 'woocommerce'), $Message, '');
                            $Note = apply_filters('WC_ATIPAY_PG_Return_from_Gateway_Failed_Note', $Note, $order_id, $traceNumber, $Fault);
                            if ($Note)
                                $order->add_order_note($Note, 1);
                            $Notice = wpautop(wptexturize($this->msg_show_failed));
                            $Notice = str_replace("{transaction_id}", $traceNumber, $Notice);

                            $Notice = str_replace("{fault}", $Message, $Notice);
                            $Notice = apply_filters('WC_ATIPAY_PG_Return_from_Gateway_Failed_Notice', $Notice, $order_id, $traceNumber, $Fault);
                            if ($Notice)
                                wc_add_notice($Notice, 'error');

                            do_action('WC_ATIPAY_PG_Return_from_Gateway_Failed', $order_id, $Transaction_ID, $Fault);
                            wp_redirect($woocommerce->cart->get_checkout_url());
                            exit;
                        }
                    }else{
                        $traceNumber = get_post_meta($order_id, '_transaction_id', true);
                        $Notice = wpautop(wptexturize($this->msg_show_success));
                        $Notice = str_replace("{transaction_id}", $traceNumber, $Notice);
                        $Notice = apply_filters('WC_ATIPAY_PG_Return_from_Gateway_ReSuccess_Notice', $Notice, $order_id, $traceNumber);
                        if ($Notice){
                            wc_add_notice($Notice, 'success');
                        }
                        do_action('WC_ATIPAY_PG_Return_from_Gateway_ReSuccess', $order_id, $traceNumber);

                        wp_redirect(add_query_arg('wc_status', 'success', $this->get_return_url($order)));
                        exit;
                    }
                }else{
                    $Fault = __(atipay_message('no_order_found'), 'woocommerce');
                    $Notice = wpautop(wptexturize($this->msg_show_failed));
                    $Notice = str_replace("{fault}", $Fault, $Notice);
                    $Notice = apply_filters('WC_ATIPAY_PG_Return_from_Gateway_No_Order_ID_Notice', $Notice, $order_id, $Fault);
                    $traceNumber = get_post_meta($order_id, '_transaction_id', true);
                    if ($Notice)
                        wc_add_notice($Notice, 'error');

                    do_action('WC_ATIPAY_PG_Return_from_Gateway_No_Order_ID', $order_id, $traceNumber, $Fault);

                    wp_redirect($woocommerce->cart->get_checkout_url());
                    exit;
                }
            }

        }

    }
}

add_action('plugins_loaded', 'Load_AtiPay_PG', 0);
